<?php

namespace Teknisa\CADEST\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Teknisa\CADEST\Services\Ger03800ProdutosPorUnidadeService;
use Teknisa\Libs\Util\Utilities;


class Ger03800ProdutosPorUnidadeController extends \Teknisa\CADEST\Controllers\TeknisaCrud {
	protected $dataSourceName;
    protected $service;
    protected $utilities;
     
    public function __construct($crudService, ParameterBag $parameterBag, $service, Utilities $utilities) {
        $this->service = $service;
        $this->utilities = $utilities;
        parent::__construct($crudService, $parameterBag);
    }

    public function cadastroAutomaticoCtrlEstoq(DTO\Request $request, DTO\Response $response) {

        try{
            $this->dataSourceName = 'prodfili_produto_ctrlestq';
            $row = $request->getRow();
            
            $this->service->cadastroAutomaticoControleEstoque($row);
        }
        catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function cadastroAutomaticoProdFili(DTO\Request $request, DTO\Response $response) {
        try{
            $this->dataSourceName = 'prodporfili_produto';
            $row = $request->getRow();

            $this->service->cadastroAutomaticoProdutoFilial($row);
        }
        catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function atualizaProdFili(DTO\Request $request, DTO\Response $response) {
        try{
            $row = $request->getRow();

            $this->service->atualizaProdFili($row);
        }
        catch(\Exception $e) {
            throw $e;
        }
    }
}