/******************************************************************************/
/* Sistemas Integrados TECNISA                                                */
/*                                                                            */
/* Compras e Suprimentos                                                      */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/* Nome: CARREGA_PERIFORN                                                     */
/*                                                                            */
/* Criao:                                                                   */
/*    06/05/2003 - Joo Fernando dos Reis Corra                              */
/*                                                                            */
/* Manutenes:                                                               */
/*   /  /   -                                                                 */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE PROCEDURE CARREGA_PERIFORN
(
   P_CDFILIAL        IN FILIAL.CDFILIAL%TYPE,
   P_CDFORNECED      IN FORNECEDOR.CDFORNECED%TYPE,
   P_DTPROGENTAF     IN DATE,
   P_NEW_DTPROGENTAF OUT DATE
)
IS
   V_CDPERIENTR VARCHAR2(2);
   V_IDTIPODIA  VARCHAR2(1);
   V_IDDIANUTIL VARCHAR2(1);
   V_DIENTREGA  VARCHAR2(3);
   V_DTDIAENTR  VARCHAR2(3);
   V_COUNT      NUMBER;
   V_EXISTE     CHAR(1);
   V_DATA       DATE;
   V_IDUTCALENDCMPGERACAOAF VARCHAR(1);
   V_CALEVAZIA  VARCHAR2(1) := 'N';
BEGIN
   SELECT
      MAX(REFORFIL.CDPERIENTR),
      MAX(PERIENTR.IDTIPODIA),
      MAX(PERIENTR.IDDIANUTIL),
      NVL(MAX(REFORFIL.IDUTCALENDCMPGERACAOAF),'N')
   INTO
      V_CDPERIENTR, V_IDTIPODIA, V_IDDIANUTIL, V_IDUTCALENDCMPGERACAOAF
   FROM
      REFORFIL, PERIENTR
   WHERE
      REFORFIL.CDPERIENTR = PERIENTR.CDPERIENTR AND
      REFORFIL.CDFORNECED = P_CDFORNECED AND
      REFORFIL.CDFILIAL = P_CDFILIAL;
   P_NEW_DTPROGENTAF := P_DTPROGENTAF;
   IF V_IDTIPODIA = 'S' THEN
      IF V_IDUTCALENDCMPGERACAOAF = 'S' THEN
         SELECT MAX(C.DTENTREGA)
           INTO P_NEW_DTPROGENTAF
           FROM CALECOMP C
          WHERE C.CDFILIAL    = P_CDFILIAL
            AND C.CDPERIENTR  = V_CDPERIENTR
            AND C.DTENTREGA  <= P_DTPROGENTAF;
         IF P_NEW_DTPROGENTAF IS NULL THEN
            V_CALEVAZIA := 'S';
         END IF;
      END IF;
      IF (P_NEW_DTPROGENTAF IS NULL) OR (V_IDUTCALENDCMPGERACAOAF = 'N') THEN
         V_DATA := TRUNC(P_DTPROGENTAF);
         WHILE V_EXISTE IS NULL LOOP
            V_EXISTE := NULL;
            BEGIN
               SELECT '1' INTO V_EXISTE
                 FROM DIASENTR
                WHERE TO_NUMBER(TO_CHAR(V_DATA, 'D')) = TO_NUMBER(DIASENTR.DIENTREGA)
                  AND DIASENTR.CDPERIENTR = V_CDPERIENTR
                  AND (TRUNC((TO_NUMBER(TO_CHAR(V_DATA, 'DD')) + 6) / 7) + IDOCOR01 = 2 OR
                      TRUNC((TO_NUMBER(TO_CHAR(V_DATA, 'DD')) + 6) / 7) + IDOCOR02 = 3 OR
                      TRUNC((TO_NUMBER(TO_CHAR(V_DATA, 'DD')) + 6) / 7) + IDOCOR03 = 4 OR
                      TRUNC((TO_NUMBER(TO_CHAR(V_DATA, 'DD')) + 6) / 7) + IDOCOR04 = 5 OR
                      TRUNC((TO_NUMBER(TO_CHAR(V_DATA, 'DD')) + 6) / 7) + IDOCOR05 = 6);
            EXCEPTION
               WHEN NO_DATA_FOUND THEN BEGIN
                  V_EXISTE := NULL;
               END;
            END;
            IF V_EXISTE IS NOT NULL THEN
               P_NEW_DTPROGENTAF := V_DATA;
            ELSE
               V_DATA := V_DATA - 1;
            END IF;
            IF (P_DTPROGENTAF - V_DATA) > 31 THEN
               V_EXISTE := '1';
            END IF;
         END LOOP;
      END IF;
   END IF;
   IF V_IDTIPODIA = 'R' THEN
      SELECT
         MAX(C.DTENTREGA) INTO P_NEW_DTPROGENTAF
      FROM
         CALECOMP C
      WHERE C.CDFILIAL    = P_CDFILIAL
        AND C.CDPERIENTR  = V_CDPERIENTR
        AND C.DTENTREGA  <= P_DTPROGENTAF;

      IF P_NEW_DTPROGENTAF IS NULL THEN
         P_NEW_DTPROGENTAF := P_DTPROGENTAF;
      END IF;
   END IF;
   IF V_IDTIPODIA = 'M' THEN
      IF V_IDUTCALENDCMPGERACAOAF = 'S' THEN
         SELECT MAX(C.DTENTREGA)
           INTO P_NEW_DTPROGENTAF
           FROM CALECOMP C
          WHERE C.CDFILIAL    = P_CDFILIAL
            AND C.CDPERIENTR  = V_CDPERIENTR
            AND C.DTENTREGA  <= P_DTPROGENTAF;
      END IF;
      IF (P_NEW_DTPROGENTAF IS NULL) OR (V_IDUTCALENDCMPGERACAOAF = 'N') THEN
         SELECT MAX(DIENTREGA)
           INTO V_DIENTREGA
           FROM (SELECT '-'||DIENTREGA DIENTREGA
                   FROM DIASENTR
                  WHERE CDPERIENTR = V_CDPERIENTR
                  UNION ALL
                 SELECT DIENTREGA
                   FROM DIASENTR
                  WHERE CDPERIENTR = V_CDPERIENTR)
          WHERE DIENTREGA <= TO_CHAR(P_DTPROGENTAF, 'DD');
         IF SUBSTR(V_DIENTREGA, 1, 1) = '-' THEN
            V_DTDIAENTR := SUBSTR(V_DIENTREGA, 2, 2);
            IF TO_NUMBER(V_DTDIAENTR) > TO_NUMBER(TO_CHAR(LAST_DAY(ADD_MONTHS(LAST_DAY(P_DTPROGENTAF)+1,-2)), 'DD')) THEN
               V_DIENTREGA := '-'||TO_CHAR(LAST_DAY(ADD_MONTHS(LAST_DAY(P_DTPROGENTAF)+1,-2)), 'DD');
            END IF;
            P_NEW_DTPROGENTAF := TO_DATE(SUBSTR(V_DIENTREGA, 2, 2)||TO_CHAR(ADD_MONTHS(P_DTPROGENTAF, -1), 'MMYYYY'), 'DDMMYYYY');
         ELSE
            V_DTDIAENTR := V_DIENTREGA;
            IF TO_NUMBER(V_DTDIAENTR) > TO_NUMBER(TO_CHAR(LAST_DAY(ADD_MONTHS(LAST_DAY(P_DTPROGENTAF)+1,-1)), 'DD')) THEN
               V_DIENTREGA := TO_CHAR(LAST_DAY(ADD_MONTHS(LAST_DAY(P_DTPROGENTAF)+1,-1)), 'DD');
            END IF;
            P_NEW_DTPROGENTAF := TO_DATE(V_DIENTREGA||TO_CHAR(P_DTPROGENTAF, 'MMYYYY'), 'DDMMYYYY');
         END IF;
      END IF;
   END IF;

   IF V_IDDIANUTIL = 'S' THEN
      IF V_CALEVAZIA = 'N' THEN
         SELECT COUNT(*) INTO V_COUNT
           FROM FERICOMP
          WHERE CDFILIAL   = P_CDFILIAL
            AND DTFERICOMP = P_NEW_DTPROGENTAF;
         IF V_COUNT > 0 THEN
            CARREGA_PERIFORN(P_CDFILIAL, P_CDFORNECED, P_NEW_DTPROGENTAF - 1, P_NEW_DTPROGENTAF);
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('CARREGA_PERIFORN','6.10.000'); END;
/

